import graphene
from cpl_core.dependency_injection import ServiceProviderABC

from bot_data.abc.queryABC import QueryABC
from bot_data.graphql.types.server_query_type import ServerQueryType
from bot_data.service.server_repository_service import ServerRepositoryService


class ServerQuery(QueryABC):
    servers = graphene.List(ServerQueryType)

    @staticmethod
    @ServiceProviderABC.inject
    def _get_servers(servers: ServerRepositoryService):
        return servers.get_servers()

    @classmethod
    def resolve_servers(cls, root, info):
        return cls._servers
