from graphene import Int, DateTime, String, List

from bot_data.abc.queryABC import QueryABC
from bot_data.graphql.types.client_query_type import ClientQueryType
from bot_data.model.server import Server


class ServerQueryType(QueryABC):
    id = Int()
    discord_server_id = String()

    created_at = DateTime()
    modified_at = DateTime()

    clients = List(ClientQueryType)

    @staticmethod
    def resolve_id(server: Server, info):
        return server.server_id

    @classmethod
    def resolve_clients(cls, server: Server, info):
        return cls._clients.where(lambda c: c.server.server_id == server.server_id)
